registerInputEvent( "fxDTSBrick", "onDetectSuccess", "Self fxDTSBrick" );
registerInputEvent( "fxDTSBrick", "onDetectFailure", "Self fxDTSBrick" );
registerOutputEvent( "fxDTSBrick", "detectBrick", "int -1 1 0\tint -1 1 0\tint -1 1 0", true );

function fxDTSBrick::detectBrick( %this, %x, %y, %z, %cl )
{
	$InputTarget_Self = %this;

	%x = mFloatLength( %x, 0 );
	%y = mFloatLength( %y, 0 );
	%z = mFloatLength( %z, 0 );

	%x = mClamp( %x, -1, 1 );
	%y = mClamp( %y, -1, 1 );
	%z = mClamp( %z, -1, 1 );

	%start = %this.getWorldBoxCenter();
	%path = %x SPC %y SPC %z;

	%beam = vectorScale( %path, 2000 );
	%stop = vectorAdd( %start, %beam );

	%ray = containerRayCast( %start, %stop, $TypeMasks::fxBrickObjectType, %this );
	%col = firstWord( %ray );

	if ( isObject( %col ) )
	{
		%this.processInputEvent( "onDetectSuccess", %cl );
	}
	else
	{
		%this.processInputEvent( "onDetectFailure", %cl );
	}
}